from peak.util.imports import whenImported, lazyModule as lazy_import, importString as import_string
from mext.classhacks import inject
from mext.funchacks import *

__all__ = ['onimport', 'onimport_cls', 'autoonimport',
            'inject', 'whenImported', 'lazy_import', 'import_string']

def autoonimport(func):
    def autoonimport_wrapped(cls, *args, **kw):
        if isinstance(cls, str):
            onimport_cls(cls, lambda cls: func(cls, *args, **kw))
        else:
            return func(cls, *args, **kw)
    return autoonimport_wrapped


@autodecorate
def onimport_cls(path, cb, *args):
    path, name = path.rsplit('.', 1)
    def import_cb(mod):
        cls = getattr(mod, name)
        cb(cls, *args)
    whenImported(path, import_cb)
    return cb

def onimport(path, *extra):
    def decorate(func):
        if extra:
            def cb(mod):
                onimport(*extra)(func)
        else:
            cb = func
        whenImported(path, cb)
        return func
    return decorate


## class LazyLib(object):
##     def __init__(self, parts=()):
##         self.parts = parts
##     def __getattr__(self, item):
##         return LazyLib(self.parts+(item,))
##     def __call__(self):
##         return lazy_import('.'.join(self.parts))
##
## lazylib = LazyLib()
##
